/*
 *  soapUI, copyright (C) 2004-2009 eviware.com 
 *
 *  soapUI is free software; you can redistribute it and/or modify it under the 
 *  terms of version 2.1 of the GNU Lesser General Public License as published by 
 *  the Free Software Foundation.
 *
 *  soapUI is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
 *  even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *  See the GNU Lesser General Public License for more details at gnu.org.
 */

package com.eviware.soapui.impl.wsdl.teststeps;

import java.beans.PropertyChangeEvent;
import java.util.List;
import java.util.Map;

import com.eviware.soapui.config.RestRequestStepConfig;
import com.eviware.soapui.impl.rest.RestMethod;
import com.eviware.soapui.impl.rest.RestResource;
import com.eviware.soapui.impl.support.AbstractHttpRequest;
import com.eviware.soapui.impl.wsdl.AbstractWsdlModelItem;
import com.eviware.soapui.impl.wsdl.teststeps.assertions.TestAssertionRegistry.AssertableType;
import com.eviware.soapui.model.iface.Interface;
import com.eviware.soapui.model.propertyexpansion.PropertyExpansion;
import com.eviware.soapui.model.testsuite.AssertionsListener;
import com.eviware.soapui.model.testsuite.OperationTestStep;
import com.eviware.soapui.model.testsuite.TestAssertion;
import com.eviware.soapui.model.testsuite.TestCaseRunContext;
import com.eviware.soapui.model.testsuite.TestCaseRunner;
import com.eviware.soapui.model.testsuite.TestStep;
import com.eviware.soapui.model.testsuite.TestStepResult;
import com.eviware.soapui.support.resolver.ResolveContext;

public interface RestTestRequestStepInterface extends HttpTestRequestStepInterface, OperationTestStep
{
	public RestRequestStepConfig getRequestStepConfig();

	public String getService();

	public String getResourcePath();

	public RestMethod getRestMethod();

	public RestResource getResource();

	public void release();

	public void propertyChange( PropertyChangeEvent evt );

	public boolean dependsOn( AbstractWsdlModelItem<?> modelItem );

	public void setResource( RestResource operation );

	public RestTestRequestInterface getTestRequest();

	public Interface getInterface();

	public TestStep getTestStep();

	public void resolve( ResolveContext<?> context );

	public PropertyExpansion[] getPropertyExpansions();

	public AbstractHttpRequest<?> getHttpRequest();

	public TestAssertion addAssertion( String type );

	public void addAssertionsListener( AssertionsListener listener );

	public TestAssertion cloneAssertion( TestAssertion source, String name );

	public String getAssertableContent();

	public AssertableType getAssertableType();

	public TestAssertion getAssertionByName( String name );

	public List<TestAssertion> getAssertionList();

	public AssertionStatus getAssertionStatus();

	public void removeAssertion( TestAssertion assertion );

	public void removeAssertionsListener( AssertionsListener listener );

	public Map<String, TestAssertion> getAssertions();

	public WsdlMessageAssertion getAssertionAt( int index );

	public int getAssertionCount();

	public String getDefaultAssertableContent();

	public TestStepResult run( TestCaseRunner runner, TestCaseRunContext runContext );

}